creeps = {}
waitingCreeps = {}
creepTypes = {}
waves = {}

currentWave = 0
sendTimer = 1
creepSendInterval = 30

function setCreepStartImage()
	if checkpoints[1].x < checkpoints[2].x then
		creepStartImage = 2
	elseif checkpoints[1].x > checkpoints[2].x then
		creepStartImage = 4
	elseif checkpoints[1].y < checkpoints[2].y then
		creepStartImage = 3
	elseif checkpoints[1].y > checkpoints[2].y then
		creepStartImage = 1
	end
end

function newCreepType(img,speed,value,hp)
	local imgs = createCreepRotations(img)
	table.insert(creepTypes,{imgs=imgs,speed=speed,value=value,hp=hp})
end

function processCreeps()
	if table.getn(creeps) < 1 then return end
	local i = 1
	local hcps = math.floor(checkpointSize/2)
	while i <= table.getn(creeps) do
		if creeps[i].x < (checkpoints[creeps[i].ccp].x+((32-creeps[i].w)/2)-2) then --if the creep's x and the center of the creep aren't within half of checkpointsize of the checkpoint it's heading to's x then move it closer
			creeps[i].x = creeps[i].x + creeps[i].speed
		elseif creeps[i].x > (checkpoints[creeps[i].ccp].x+((32-creeps[i].w)/2)+2) then
			creeps[i].x = creeps[i].x - creeps[i].speed
		elseif creeps[i].y < (checkpoints[creeps[i].ccp].y+((32-creeps[i].h)/2)-2) then --same but for y
			creeps[i].y = creeps[i].y + creeps[i].speed
		elseif creeps[i].y > (checkpoints[creeps[i].ccp].y+((32-creeps[i].h)/2)+2) then
			creeps[i].y = creeps[i].y - creeps[i].speed
		else --or if the creep is at the checkpoint, make its checkpoint the next one
			creeps[i].x = checkpoints[creeps[i].ccp].x
			creeps[i].y = checkpoints[creeps[i].ccp].y
			creeps[i].ccp = creeps[i].ccp + 1

			if creeps[i].ccp > table.getn(checkpoints) then --if the creep has made it to the end
				table.remove(creeps,i)
				lives = lives - 1
			else
				if creeps[i].x < (checkpoints[creeps[i].ccp].x-8) then --figure out which direction it is to the next checkpoint to the next checkpoint and change the creep's sprite accordingly
					creeps[i].img = creeps[i].type.imgs[2]
				elseif creeps[i].x > (checkpoints[creeps[i].ccp].x+8) then
					creeps[i].img = creeps[i].type.imgs[4]
				elseif creeps[i].y < (checkpoints[creeps[i].ccp].y-8) then
					creeps[i].img = creeps[i].type.imgs[3]
				elseif creeps[i].y > (checkpoints[creeps[i].ccp].y+8) then
					creeps[i].img = creeps[i].type.imgs[1]
				end
				creeps[i].w = creeps[i].img:width()
				creeps[i].h = creeps[i].img:height()
			end
		end
		i = i + 1
	end
end

function createCreepRotations(img)
	local it = {}
	it[1] = img
	local w = img:width()
	local h = img:height()
	it[2] = Image.createEmpty(h,w)
	it[3] = Image.createEmpty(w,h)
	it[4] = Image.createEmpty(h,w)
	for i = 0, (w-1) do
		for j = 0, (h-1) do
			local c = img:pixel(i,j)
			it[2]:pixel(h-j-1,i,c)
			it[3]:pixel(i,h-j-1,c)
			it[4]:pixel(j,w-i-1,c)
		end
	end
	return it
end

function processWaveSending()
	if gamestarted and currentWave ~= table.getn(waves) then
		if pad:square() and not oldpad:square() then
			waveTimer = timeBetweenWaves
		else
			waveTimer = waveTimer + 1
		end
		if waveTimer >= timeBetweenWaves and currentWave < table.getn(waves) then
			currentWave = currentWave + 1
			local cw = currentWave
			local type = creepTypes[waves[cw].type]
			currentWavehp = math.floor(type.hp*waves[cw].hpm+0.5)
			currentWaveValue = math.floor(type.value*waves[cw].vm+0.5)
			local w = type.imgs[creepStartImage]:width()
			local h = type.imgs[creepStartImage]:height()
			for i = 1, waves[cw].numCreeps do
				table.insert(waitingCreeps,{x = checkpoints[1].x+((32-w)/2),y = checkpoints[1].y+((32-h)/2), ccp = 2,value=currentWaveValue,w = w,h = h,img=type.imgs[creepStartImage],type = type,hp = currentWavehp,shp = currentWavehp,speed = type.speed})
			end
			numWaiting = table.getn(waitingCreeps)
			waveTimer = 0
		end
	end
end

function addWave(type,nc,hpm,vm)
	table.insert(waves,{type = type,numCreeps = nc,hpm = hpm,vm = vm})
end

function processCreepSending()
	if sendTimer > creepSendInterval then
		addedcreep = waitingCreeps[1]
		table.insert(creeps,addedcreep)
		table.remove(waitingCreeps,1)
		sendTimer = 1
		numWaiting = table.getn(waitingCreeps)
	end
	sendTimer = sendTimer + 1
end
