--thanks to FxN for the drawCircle function
function drawCircle(t,x,y,r,c)
local d = 0
r = r - 1
	while d < (6.4) do
		t:pixel((math.floor(r*math.cos(d)))+x, (math.floor(r*math.sin(d)))+y,c)
		d = d + 0.005
	end
end

function drawRect(x,y,w,h,c,t)
	t = t or screen
	t:drawLine(x,y,x+w-1,y,c)
	t:drawLine(x,y,x,y+h-1,c)
	t:drawLine(x,y+h-1,x+w-1,y+h-1,c)
	t:drawLine(x+w-1,y,x+w-1,y+h-1,c)
end

function Gu.blit(x,y,img)
	local w = img:width()
	local h = img:height()
	Gu.enable(Gu.TEXTURE_2D) 
	Gu.texImage(img)
	Gum.drawArray(Gu.SPRITES, Gu.TEXTURE_32BITF+Gu.VERTEX_32BITF+Gu.TRANSFORM_2D,{{0,0,x,y,0},{w,h,w+x,h+y,0}})
end

function collision(ob1,ob2)
	return (ob1.x + ob1.w > ob2.x) and (ob1.x < ob2.x + ob2.w) and (ob1.y + ob1.h > ob2.y) and (ob1.y < ob2.y + ob2.h)
end

function newCheckpoint(x,y)
	if x > (fieldwidth-1) or x < 0 or y > (fieldheight-1) or y < 0 then return false end
	table.insert(checkpoints,{x = x, y = y})
end

function generatefieldimg()
	for i = 1, fieldheight do
		for j = 1, fieldwidth do
			fieldimg:blit((j-1)*32,(i-1)*32,tilemap[i][j])
		end
	end
end

function resetTilemap()
	for i = 1, fieldheight do
		tilemap[i] = {}
		for j = 1, fieldwidth do
			tilemap[i][j] = blank
		end
	end
end

function processCursor()
	if pad:left() and not oldpad:left() and c.x > 0 then
		c.x = c.x - 1
	elseif pad:right() and not oldpad:right() and c.x < (fieldwidth-1) then
		c.x = c.x + 1
	elseif pad:up() and not oldpad:up() and c.y > 0 then
		c.y = c.y - 1
	elseif pad:down() and not oldpad:down() and c.y < (fieldheight-1) then
		c.y = c.y + 1
	end
	if c.x ~= c.ox or c.y ~= c.oy then
		if tilemap[c.y+1][c.x+1] == turret then
			for i = 1, table.getn(turrets) do
				if turrets[i].x == c.x*32 and turrets[i].y == c.y*32 then
					selectedTurret = i
					break
				end
			end
		else
			selectedTurret = 0
		end
	end
end

function drawPathways()
	tilemap[checkpoints[table.getn(checkpoints)].y+1][checkpoints[table.getn(checkpoints)].x+1] = path
	for i = 1, table.getn(checkpoints)-1 do
		tilemap[checkpoints[i].y+1][checkpoints[i].x+1] = path
		local xd = checkpoints[i].x - checkpoints[i+1].x
		local yd = checkpoints[i].y - checkpoints[i+1].y
		if yd < 0 then
			for j = 1, math.abs(yd) do
				tilemap[checkpoints[i].y+1+j][checkpoints[i].x+1] = path
			end
		elseif yd > 0 then
			for j = yd, 1, -1 do
				tilemap[checkpoints[i].y+1-j][checkpoints[i].x+1] = path
			end
		elseif xd < 0 then
			for j = 1, math.abs(xd) do
				tilemap[checkpoints[i].y+1][checkpoints[i].x+1+j] = path
			end
		elseif xd > 0 then
			for j = xd, 1, -1 do
				tilemap[checkpoints[i].y+1][checkpoints[i].x+1-j] = path
			end
		end
	end
end

function nws()
	if currentWave ~= table.getn(waves) then return "next wave in "..(math.floor((timeBetweenWaves-waveTimer)/30+0.5)) else return "final wave." end
end
