white = Color.new(255,255,255)
black = Color.new(0,0,0)
selectColor = Color.new(0,100,170)

healthBarColor = Color.new(255,0,0)

bigfont = Font.createMonoSpaced()
bigfont:setPixelSizes(32,32)
screen:fontPrint(bigfont,98,25,"Please vote for",white)
screen:fontPrint(bigfont,216,96,"PSP",white)
screen:fontPrint(bigfont,117,130,"Tower Defense",white)
screen:fontPrint(bigfont,185,224,"in the",white)
screen.flip()
screen.waitVblankStart(120)

fader = Image.createEmpty(480,272)
nfs = Image.load("neoflashsplash.png")
for i = 40, 0, -1 do
	screen:clear()
	fader:clear(Color.new(0,0,0,i*5))
	screen:blit(0,0,nfs)
	screen:blit(0,0,fader)
	screen.waitVblankStart()
	screen.flip()
end
screen.waitVblankStart(60)
for i = 0, 51 do
	screen:clear()
	fader:clear(Color.new(0,0,0,i*5))
	screen:blit(0,0,nfs)
	screen:blit(0,0,fader)
	screen.waitVblankStart()
	screen.flip()
end
fader = nil
nfs = nil
bigfont = nil

--menu stuff:
menuitems = {
"Instructions",
"Start Game",
"Choose Level:",
"Delete Level:",
"Make Level",
"Credits"
}
ms,mms = 1,table.getn(menuitems)

menubox = Image.load("menubox.png")
for i = 1, mms do
	menubox:print(5,8+((i-1)*16),menuitems[i],black)
end

--menu background changing stuff:

bgslides = {}
currentSlide = 1
slideTimer = 0
numBGSlides = 5
for i = 1, numBGSlides do
	bgslides[i] = Image.load("backgrounds/"..i..".png")
end

sx = 0

--menu level select/delete stuff:
levels = System.listDirectory("maps")
table.remove(levels,1)
table.remove(levels,1)
numLevels = table.getn(levels)
ls = 1
ds = 1

fpst = Timer.new()
fps = 30

--dofile the rest of the files:
dofile("shooting.lua")
dofile("turrets.lua")
dofile("creeps.lua")
dofile("funcs.lua")

--checkpoints and some default settings
checkpoints = {}
lives = 20
money = 100
timeBetweenWaves = 600
gamestarted = false
checkpointSize = 32



--the tilemap/field background and a couple tiles

tilemap = {}
fieldheight = 8
fieldwidth = 12
fieldimg = Image.createEmpty(fieldwidth*turretSize,fieldheight*turretSize)
resetTilemap()
blank = Image.load("blank.png")
--blank:clear(white)
path = Image.load("path.png")
--path:clear(Color.new(128,64,0))
--cursor box stuff:

greenimg = Image.createEmpty(32,32)
greenimg:clear(Color.new(0,255,0,150))
drawRect(0,0,32,32,black,greenimg)

redimg = Image.createEmpty(32,32)
redimg:clear(Color.new(255,0,0,150))
drawRect(0,0,32,32,black,redimg)

oldpad = Controls.read()
while true do
	screen:clear()
	pad = Controls.read()
	if slideTimer > 300 then
		slideTimer = 0
		sx = 480
		currentSlide = currentSlide + 1
		if currentSlide > numBGSlides then currentSlide = 1 end
	end
	if sx > 0 then sx = sx - 4 else slideTimer = slideTimer + 1 end
	screen:blit(sx,0,bgslides[currentSlide])
	screen:blit(20,20,menubox)

	if pad:up() and not oldpad:up() and ms > 1 then
		ms = ms - 1
	elseif pad:down() and not oldpad:down() and ms < mms then
		ms = ms + 1
	end

	screen:print(129,60,string.sub(string.sub(levels[ls].name,1,-5),1,9),black)
	screen:print(129,76,string.sub(string.sub(levels[ds].name,1,-5),1,9),black)

	if ms == 3 then
		if pad:left() and not oldpad:left() then
			ls = ls - 1
		elseif pad:right() and not oldpad:right() then
			ls = ls + 1
		end
		if ls > numLevels then ls = 1 elseif ls < 1 then ls = numLevels end
		screen:print(129,60,string.sub(string.sub(levels[ls].name,1,-5),1,9),selectColor)
	elseif ms == 4 then
		if pad:left() and not oldpad:left() then
			ds = ds - 1
		elseif pad:right() and not oldpad:right() then
			ds = ds + 1
		end
		if ds > numLevels then ds = 1 elseif ds < 1 then ds = numLevels end
		screen:print(129,76,string.sub(string.sub(levels[ds].name,1,-5),1,9),selectColor)
	end

	screen:print(25,ms*16+12,menuitems[ms],selectColor)
 
	if pad:cross() and not oldpad:cross() then
		if ms == 1 then --instructions
			instructions = Image.load("instructions.png")
			screen:blit(0,0,instructions)
			screen.flip()
			while not Controls.read():circle() do
				screen.waitVblankStart()
			end
			instructions = nil
		elseif ms == 2 then --start game
			if levels[ls].name ~= "NoLevels" then
				--reset stuff so we dont go back into playing our last game
				lives = 20
				money = 100
				timeBetweenWaves = 600
				gamestarted = false
				checkpointSize = 32
				creeps = {}
				waitingCreeps = {}
				creepTypes = {}
				turrets = {}
				turretTypes = {}
				turretSelect = 1
				selectedTurret = 0
				bullets = {}
				checkpoints = {}
				waves = {}
				selectedTurret = 0
				currentWave = 0
				sendTimer = 0
				c = {x = 0, y = 0}
				
				dofile("maps/"..levels[ls].name)
				resetTilemap()
				drawPathways()
				for i = 1, table.getn(checkpoints) do
					checkpoints[i].x = checkpoints[i].x*32
					checkpoints[i].y = checkpoints[i].y*32
				end
				generatefieldimg()
				setCreepStartImage()
				while not gameover do
					screen:clear(white)
					oldpad = pad
					c.ox = c.x
					c.oy = c.y
					pad = Controls.read()

					if (pad:start() and not oldpad:start()) or lives < 1 then
						if gamestarted then
							screen:clear()
							screen:print(204,131,"Gameover!",white)
							screen.flip()
							screen.waitVblankStart(120)
							break
						else
							gamestarted = true
							waveTimer = timeBetweenWaves
						end
					end

					processCreepSending()

					processTurrets()
					processBullets()
					processCreeps()

					processTurretPlacement()

					processWaveSending()

					processCursor()

					screen:blit(0,0,fieldimg)
					Gu.start3d()
						for i = 1, table.getn(creeps) do
							Gu.blit(creeps[i].x,creeps[i].y,creeps[i].img)
						end
						for i = 1, table.getn(bullets) do
							Gu.blit(bullets[i].x,bullets[i].y,bullets[i].img)
						end

						if tilemap[c.y+1][c.x+1] == blank then
							Gu.blit(c.x*32,c.y*32,greenimg)
							--[[Gu.blit(c.x*32+16-turretTypes[turretSelect].range,c.y*32+15-turretTypes[turretSelect].range,turretTypes[turretSelect].rcimg)
						elseif tilemap[c.y+1][c.x+1] == turret then
							Gu.blit(c.x*32+16-turrets[selectedTurret].type.range,c.y*32+15-turrets[selectedTurret].type.range,turrets[selectedTurret].type.rcimg)
							Gu.blit(c.x*32,c.y*32,redimg)]]
						else
							Gu.blit(c.x*32,c.y*32,redimg)
						end
					Gu.end3d()

					if tilemap[c.y+1][c.x+1] == blank then
						screen:blit(c.x*32+16-turretTypes[turretSelect].range,c.y*32+15-turretTypes[turretSelect].range,turretTypes[turretSelect].rcimg)
					elseif tilemap[c.y+1][c.x+1] == turret then
						screen:blit(c.x*32+16-turrets[selectedTurret].type.range,c.y*32+15-turrets[selectedTurret].type.range,turrets[selectedTurret].type.rcimg)
					end

					for i = 1, table.getn(turrets) do
						screen:drawLine(turrets[i].x+hts-1,turrets[i].y+hts-1,turrets[i].mx,turrets[i].my,turrets[i].type.color)
					end
					for i = 1, table.getn(creeps) do
						screen:drawLine(creeps[i].x+8,creeps[i].y,creeps[i].x+8+(16*(creeps[i].hp/creeps[i].shp)),creeps[i].y,healthBarColor)
					end
					screen:print(386,2,"Money: "..money)
					screen:print(386,12,"Lives: "..lives)
					if selectedTurret > 0 then
						screen:print(386,32,"Turret info:")
						screen:print(386,42,turrets[selectedTurret].type.name)
						screen:print(386,52,30/turrets[selectedTurret].type.rtfr.." shots/s")
						screen:print(386,62,turrets[selectedTurret].dmg.." dmg/shot")
						screen:print(386,72,"Range: "..turrets[selectedTurret].type.range)
						screen:print(386,82,"Level: "..turrets[selectedTurret].lv)
						screen:print(386,92,"Value: "..turrets[selectedTurret].sv)
					end
					if gamestarted then
						if table.getn(creeps) < 1 and table.getn(waitingCreeps) < 1 and currentWave == table.getn(waves) then
							screen:print(208,131,"You win!")
							screen.flip()
							screen.waitVblankStart(120)
							break
						end
						screen:print(2,258,"Wave "..currentWave..", "..waves[currentWave].numCreeps.." creeps, "..currentWavehp.." hp each, worth "..currentWaveValue..", "..nws())
					end
					screen:print(0,0,math.floor(fps),black)
					screen.waitVblankStart()
					if 1000/fpst:time() > 50 then
						screen.waitVblankStart()
					end
					fps = 1000/fpst:time()
					fpst:reset()
					fpst:start()
					screen.flip()
				end
				fpst:reset()
				gameover = false
			end
		elseif ms == 4 then --remove map
			System.removeFile("maps/"..levels[ds].name)
			table.remove(levels,ds)
			if table.getn(levels) < 1 then
				table.insert(levels, {name = "NoLevels"})
				ls = 1
				ds = 1
			end
			numLevels = table.getn(levels)
			if ls > numLevels then ls = numLevels end
			if ds > numLevels then ds = numLevels end
		elseif ms == 5 then --level maker
			dofile("levelmaker.lua")
		elseif ms == 6 then --credits
			credits = Image.load("credits.png")
			screen:blit(0,0,credits)
			screen.flip()
			while not Controls.read():circle() do
				screen.waitVblankStart()
			end
			credits = nil
		end
	end

	if pad:select() then break end

	screen.waitVblankStart()
	screen.flip()
	oldpad = pad
end
