turrets = {}
turretSize = 32
hts = turretSize/2
turretSelect = 1
selectedTurret = 0
turretTypes = {}
turret = Image.createEmpty(turretSize,turretSize)

function newTurretType(name,cost,firedelay,range,dmg,bimg,color)
	if range > 256 then range = 256 end
	local rcimg = Image.createEmpty(range*2,range*2)
	drawCircle(rcimg,range,range,range,black)
	table.insert(turretTypes,{name = name, cost = cost,rtfr = firedelay, range = range, dmg = dmg, bimg = bimg, color = color,rcimg = rcimg})
end

function newTurret(x,y,type) --a is angle, rtf is ready to fire, rtfc is ready to fire counter
	table.insert(turrets,{x = x, y = y, type = turretTypes[type],mx = x + 1,my=y+(turretSize/2)-1, sv = math.floor(turretTypes[type].cost/2+0.5),rtf = true, rtfc = 0,dmg = turretTypes[type].dmg,lv = 1})
	selectedTurret = table.getn(turrets)
end

function processTurretPlacement()
	if pad:l() and not oldpad:l() and turretSelect > 1 then
		turretSelect = turretSelect - 1
	elseif pad:r() and not oldpad:r() and turretSelect < table.getn(turretTypes) then
		turretSelect = turretSelect + 1
	end

	if pad:cross() and not oldpad:cross() then
		if tilemap[c.y+1][c.x+1] == blank then
			if turretTypes[turretSelect].cost <= money then
				money = money - turretTypes[turretSelect].cost
				tilemap[c.y+1][c.x+1] = turret
				newTurret(c.x*32,c.y*32,turretSelect)
				local nt = table.getn(turrets)
				drawRect(turrets[nt].x,turrets[nt].y,turretSize,turretSize,turrets[nt].type.color,fieldimg)
				drawRect(0,0,turretSize,turretSize,turrets[nt].type.color,tilemap[c.y+1][c.x+1])
			end
		end
	end

	if pad:circle() and not oldpad:circle() then
		sellTurret(c.x,c.y)
	end

	if pad:triangle() and not oldpad:triangle() then
		upgradeTurret(c.x,c.y)
	end
	screen:print(386,112,"Turret to")
	screen:print(386,122,"build:")
	screen:print(386,132,turretTypes[turretSelect].name)
	screen:print(386,142,turretTypes[turretSelect].dmg.." dmg/shot")
	screen:print(386,152,string.sub(tostring(30/turretTypes[turretSelect].rtfr),1,4).." shots/sec")
	screen:print(386,162,turretTypes[turretSelect].range.." range")
	screen:print(386,172,"Cost: "..turretTypes[turretSelect].cost)
--	screen:print(258,2,turretTypes[turretSelect].name..", "..turretTypes[turretSelect].dmg.." dmg/shot, "..string.sub(tostring(30/turretTypes[turretSelect].rtfr),1,4).." shots/sec, "..turretTypes[turretSelect].range.." range, costs "..turretTypes[turretSelect].cost,white)
end

function processTurrets()
	for i = 1, table.getn(turrets) do
		for j = 1, table.getn(creeps) do
			if math.sqrt(((turrets[i].x+hts-(creeps[j].x+(creeps[j].w/2)))^2)+((turrets[i].y+hts-(creeps[j].y+(creeps[j].h/2)))^2)) <= (turrets[i].type.range+hts) then --if the creep is within the turret's range
				local mp = getMuzzlePoint(turrets[i].x+hts-1,turrets[i].y+hts-1,creeps[j].x+(creeps[j].w/2),creeps[j].y+(creeps[j].h/2),hts-1)
				turrets[i].mx = mp.x
				turrets[i].my = mp.y
				if not turrets[i].rtf then --if the turret isn't ready to fire
					turrets[i].rtfc = turrets[i].rtfc + 1
					if turrets[i].rtfc >= turrets[i].type.rtfr then
						turrets[i].rtf = true
						turrets[i].rtfc = 0
					end
					break
				else  --otherwise it is ready so let's shoot at a creep
					turrets[i].rtf = false
					newBullet(turrets[i].x+hts,turrets[i].y+hts,turrets[i].mx,turrets[i].my,turrets[i].dmg,turrets[i].type.bimg,hts-1)
					break
				end
			end
		end
	end
end

function upgradeTurret(x,y)
	if tilemap[y+1][x+1] ~= turret then return false end
	local ugturret = 0
	for i = 1, table.getn(turrets) do
		if turrets[i].x == x*32 and turrets[i].y == y*32 then
			ugturret = i
			break
		end
	end
	local clv = turrets[ugturret].lv
	if clv > 4 then return false end
	local ugcost = math.floor((turrets[ugturret].type.cost * (1.5^(clv-1)))/2+0.5)
	if ugcost > money then return false end
	money = money - ugcost
	turrets[ugturret].lv = turrets[ugturret].lv + 1
	turrets[ugturret].sv = turrets[ugturret].sv + math.floor(ugcost/2+0.5)
	if turrets[ugturret].lv > 4 then
		turrets[ugturret].dmg = math.floor((turrets[ugturret].dmg * 2.5)+0.5)
	else
		turrets[ugturret].dmg = math.floor((turrets[ugturret].dmg * 1.5)+0.5)
	end
end

function sellTurret(x,y)
	if tilemap[y+1][x+1] ~= turret then return false end
	local soldturret = 0
	for i = 1, table.getn(turrets) do
		if turrets[i].x == x*32 and turrets[i].y == y*32 then
			soldturret = i
			break
		end
	end
	money = money + turrets[soldturret].sv
	table.remove(turrets,soldturret)
	tilemap[y+1][x+1] = blank
	fieldimg:blit(x*32,y*32,blank)
	selectedTurret = 0
end
